## ncbi-vdb 2.8.2-2+dfsg

=== debian/changelog ===
ncbi-vdb (2.8.2-2+dfsg-1build1) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:45:54 +0000

ncbi-vdb (2.8.2-2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control
  * Standards-Version: 4.1.1
  * More adaptations to Debian packaged libmbedx
  * d/rules: Do not parse changelog
  * Try better hardening

 -- Andreas Tille <tille@debian.org>  Thu, 19 Oct 2017 23:40:15 +0200

=== debian/control ===
Source: ncbi-vdb
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               d-shlibs,
               libbz2-dev,
               libxml2-dev,
               libhdf5-dev,
               libmagic-dev,
               libngs-sdk-dev,
               libngs-java,
               libmbedtls-dev,
               zlib1g-dev,
               default-jdk-headless
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ncbi-vdb.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb

Package: libncbi-vdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: libraries for using data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-vdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb2 (= ${binary:Version}),
         libkdf5-dev (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 Much of the data submitted these days, for example in BAM, Illumina
 export.txt, and Complete Genomics formats, contain alignment
 information. With aligned data, NCBI uses Compression by Reference,
 which only stores the differences in base pairs between sequence data
 and the segment it aligns to. The process to restore original data, for
 example as FastQ, requires fast access to the reference sequences that
 the original data was aligned to. NCBI recommends that SRA users
 dedicate local disk space to store references downloaded from the NCBI
 SRA site. As of Fall 2014, the complete collection of these reference
 sequences is 66 GB. While it isn't usually necessary to download the
 entirety of the reference sequences, this should give you an idea of the
 scale of the storage requirement. By default, the Toolkit will download
 missing reference sequences on demand and cache them in the user's home
 directory. The location of this cache is configurable, as is whether the
 download is automatic or manual.
 .
 This is the development package.

Package: libkdf5-2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmbedtls-dev
Description: hdf5 access to data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).

Package: libkdf5-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libkdf5-2 (= ${binary:Version})
Description: hdf5 access to data in the INSDC Sequence Read Archives (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).
 .
 This is the development package.

Package: libncbi-wvdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: virtual layer update modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.

Package: libncbi-wvdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb2 (= ${binary:Version})
Description: virtual layer update modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.
 .
 This is the development package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_BUILD_OPTIONS := nocheck

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(DEB_SOURCE)/$(OS)/gcc
VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
LIBINSTALLDIR := debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/$(VDB_ARCH)/dbg/lib
LIBPKG := libncbi-vdb2
SCHEMADIR := debian/$(LIBPKG)/usr/lib/$(DEB_SOURCE)

%:
	dh $@

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEB_SOURCE)/$(MULTIARCH)

override_dh_auto_configure:
	# that's no standard configure script lacking support of default options
	# The build system shamelessly ignores those options like
	#    --with-ngs-java-prefix=/usr/share/java
	# so we need to go with patches.  The options are specified anyway.
	ln -s /usr/lib/jvm/default-java/include/jni.h		libs/ngs-jni
	ln -s /usr/lib/jvm/default-java/include/linux/jni_md.h	libs/ngs-jni
	./configure --build=$(MULTIARCH) --prefix=/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr --with-debug --with-ngs-java-prefix=/usr/share/java
	# no idea how to convince configure script to use the correct include dir so patching result afterwards
	sed -i 's?HDF5_INCDIR = /usr/include?&/hdf5/serial?' build/Makefile.config*

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_auto_install:
	dh_auto_install
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libmbedcrypto0-dev/libmbedtls-dev/ \
		    --override s/libmbedtls10-dev/libmbedtls-dev/ \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp-norsrc.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkff.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libktst.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxfs.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxml.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libload.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui_cpp.a usr/lib/$(MULTIARCH) \
		    --movedev interfaces usr/include \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-vdb.so
	mv debian/libncbi-vdb-dev/usr/include/interfaces debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libhdf5_serial[0-9]*-dev/libhdf5-dev/ \
		    --override s/libmbedcrypto0-dev/libmbedtls-dev/ \
		    --override s/libmbedtls10-dev/libmbedtls-dev/ \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libkdf5.so
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-wvdb.so
	find debian/lib* -name .gitignore -delete
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	set -x ; \
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    sed -i "s:^include ':&/usr/lib/ncbi-vdb/:" $${schema} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done

## ncbi-vdb 2.9.0

=== libs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: default

TOP ?= $(abspath ..)
MODULE = libs

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
MAIN_SUBDIRS = \
	ext      \
	kfc      \
	klib     \
	kproc    \
	kfs      \
	kns      \
	kfg      \
	krypto   \
	vfs      \
	kapp     \
	kdb      \
	vdb      \
	vxf      \
	search   \
	sraxf    \
	align    \
	axf      \
	wgsxf    \
	ktst     \
	loader   \
	blast    \
	ascp     \
	schema   \
	sra      \
	ngs      \
	ngs-c++  \
	ngs-jni  \
	ngs-py   \
	kxml     \
	hdf5     \
	tui

NCBI_VDB_SUBDIRS =   \
	$(MAIN_SUBDIRS) \
	ncbi-vdb

SUBDIRS = \
	$(NCBI_VDB_SUBDIRS) \
	vdb-sqlite

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@
	
ncbi-vdb: $(MAIN_SUBDIRS)

vdb-sqlite: $(NCBI_VDB_SUBDIRS)

test:
	@true

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =       \
    ngs         \
    ktst        \
    cc          \
    ext         \
    judy_test   \
    kfc         \
    kfs         \
    klib        \
    kfg         \
    kapp        \
    vfs         \
    kns         \
    kdb         \
    kproc       \
    vdb         \
    ngs-c++     \
    ngs-java    \
    ngs-python  \
    search      \
    sraxf       \
    vxf         \
    loader      \
    krypto      \
    cipher      \
    install     \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/align

INT_LIBS = \
	libncbi-bam \
	libalign-writer \
	libalign-access \
	libalign-reader

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =              \
	$(BAM_OBJ)          \
	$(ALIGN_ACCESS_OBJ) \
	$(ALIGN_READER_OBJ) \
	$(ALIGN_WRITER_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# libncbi-bam
#
$(ILIBDIR)/libncbi-bam: $(addprefix $(ILIBDIR)/libncbi-bam.,$(ILIBEXT))

BAM_SRC = \
	bam

BAM_OBJ = \
	$(addsuffix .$(LOBX),$(BAM_SRC))

BAM_LIB = 

$(ILIBDIR)/libncbi-bam.$(LIBX): $(BAM_OBJ)
	$(LD) --slib -o $@ $^ $(BAM_LIB)


#-------------------------------------------------------------------------------
# align-access
#
$(ILIBDIR)/libalign-access: $(addprefix $(ILIBDIR)/libalign-access.,$(ILIBEXT))

ALIGN_ACCESS_SRC = \
	align-access

ALIGN_ACCESS_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_ACCESS_SRC))

ALIGN_ACCESS_LIB = 

$(ILIBDIR)/libalign-access.$(LIBX): $(ALIGN_ACCESS_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_ACCESS_LIB)

#-------------------------------------------------------------------------------
# align-reader
#
$(ILIBDIR)/libalign-reader: $(addprefix $(ILIBDIR)/libalign-reader.,$(ILIBEXT))

ALIGN_READER_SRC = \
	align_mgr \
	al_iterator \
	unsupported_pileup_estimator \
	ref_iterator \
	pl_iterator \
	dna-reverse-cmpl \
	reference-cmn \
	reader-cmn \
	reader-refseq \
	reader-wgs \
	reference \
	refseq-mgr \
	quality-quantizer

ALIGN_READER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_READER_SRC))

ALIGN_READER_LIB = 

$(ILIBDIR)/libalign-reader.$(LIBX): $(ALIGN_READER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_READER_LIB)

#-------------------------------------------------------------------------------
# align-writer
#
$(ILIBDIR)/libalign-writer: $(addprefix $(ILIBDIR)/libalign-writer.,$(LIBX))

ALIGN_WRITER_SRC = \
    dna-reverse-cmpl \
	reader-cmn \
	reference-cmn \
	reader-refseq \
	reader-wgs \
	refseq-mgr \
	writer-cmn \
	writer-refseq \
	writer-alignment \
	writer-sequence \
	writer-ref \
	writer-reference

ALIGN_WRITER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_WRITER_SRC))

ALIGN_WRITER_LIB = 

$(ILIBDIR)/libalign-writer.$(LIBX): $(ALIGN_WRITER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_WRITER_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/klib

INT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KLIB_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy all
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all $(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ $(MAKE) -C $(SRCDIR)/judy clean

.PHONY: clean

#-------------------------------------------------------------------------------
# klib
#
$(ILIBDIR)/libklib: $(addprefix $(ILIBDIR)/libklib.,$(ILIBEXT))

KLIB_SRC = \
	text \
	time \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	all-vdb-version \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	misc \
	SHA-32bit \
	SHA-64bit \
	qsort \
	ksort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syserrcode \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	systime \
	rc-tbl \
	rc-idx-tbl \
	judy-vector \
	report-klib \
	num-gen \
	progressbar \
	sra-release-version \
	btree
#	path

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \
	-sjudy \
	-lm

$(ILIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib -o $@ $^ $(KLIB_LIB)


# compilation
compile: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy compile
	@ $(MAKE_CMD) -j$(MAKE_JOBS) $(TARGDIR)/compile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/schema/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/schema

INT_LIBS = \
    libschema

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# schema parser library
#
$(ILIBDIR)/libschema: $(addprefix $(ILIBDIR)/libschema.,$(ILIBEXT))

SCHEMA_SRC = \
    schema-grammar \
    schema-lex \
    Token \
    SchemaScanner \
    SchemaParser \
    ParseTree \
    schema-ast \
    AST \
    ASTBuilder \
    ASTBuilder-func \
    ASTBuilder-tbl \
    ASTBuilder-db \
	ErrorReport \

schema-grammar.$(LOBX): $(SRCDIR)/schema-grammar.cpp
	$(CP) -o $@ -fPIC $(OPT) -D_LIBRARY $< $(LOC_INFO) -D__file_ext__=cpp

bison: grammar ast

grammar: $(SRCDIR)/schema-grammar.cpp

ast: $(SRCDIR)/schema-ast.cpp

#looak at the major version of Bison
BISON_VERSION = $(word 4,$(subst ., ,$(shell bison -V | grep "(GNU Bison)")))

ifeq (1,$(shell echo "3<=$(BISON_VERSION)" | bc -l))

$(SRCDIR)/schema-grammar.cpp: $(SRCDIR)/schema-grammar.y
	bison -r state -o $(SRCDIR)/schema-grammar.cpp --defines=$(SRCDIR)/schema-tokens.h $(SRCDIR)/schema-grammar.y

$(SRCDIR)/schema-ast.cpp: $(SRCDIR)/schema-ast.y
	bison -r state -o $(SRCDIR)/schema-ast.cpp --defines=$(SRCDIR)/schema-ast-tokens.h $(SRCDIR)/schema-ast.y

else

BISON_ERROR = "NOTE: The current Bison version is $(BISON_VERSION). Version 3.0 or newer is required in the PATH. Using the existing $@."
$(SRCDIR)/schema-grammar.cpp: $(SRCDIR)/schema-grammar.y
	@echo $(BISON_ERROR)

$(SRCDIR)/schema-ast.cpp: $(SRCDIR)/schema-ast.y
	@echo $(BISON_ERROR)

endif

schema-lex.$(LOBX): $(SRCDIR)/schema-lex.c
	$(CC)  -Wno-unused-function -o $@ -fPIC $(OPT) -D_LIBRARY $< $(LOC_INFO) -D__file_ext__=c

flex $(SRCDIR)/schema-lex.c: $(SRCDIR)/schema-lex.l $(SRCDIR)/schema-grammar.cpp
	flex -d -t $(SRCDIR)/schema-lex.l > $(SRCDIR)/schema-lex.c

SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SCHEMA_SRC))

$(ILIBDIR)/libschema.$(LIBX):  $(SCHEMA_OBJ)
	$(LD) --slib -o $@ $^

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

.PHONY: bison flex grammar ast

=== test/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: runtests

TOP ?= $(abspath ../..)
MODULE = test/align

TEST_TOOLS = \
	test-load-index \
	test-estimator \
    
include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

clean: stdclean

#-------------------------------------------------------------------------------
# test-load-index
#
TEST_INDEX_SRC = \
	indextest

TEST_INDEX_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_INDEX_SRC))

TEST_INDEX_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-load-index: $(TEST_INDEX_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_INDEX_LIB)


#-------------------------------------------------------------------------------
# test-estimator
#
TEST_ESTIMATOR_SRC = \
	pileup_estimator

TEST_ESTIMATOR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_ESTIMATOR_SRC))

TEST_ESTIMATOR_LIB = \
	-skapp \
	-sktst \
	-sncbi-ngs-c++ \
	-sncbi-vdb \
    -L$(NGS_LIBDIR) \
	-sngs-c++

$(TEST_BINDIR)/test-estimator: $(TEST_ESTIMATOR_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_ESTIMATOR_LIB)

=== test/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/klib

# WARNING: test-md5append is excluded from TEST_TOOLS since it's supposed
# to be run manually
TEST_TOOLS = \
	test-asm \
	test-printf \
	test-log \
	test-out \
	test-SraReleaseVersion \
	test-time \
	test-klib \
	test-vnamelist \
	test-progressbar \
    test-symtab \

include $(TOP)/build/Makefile.env

std: $(TEST_TOOLS)

test-md5append $(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# test-asm
#
TEST_ASM_SRC = \
	asm-test

TEST_ASM_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_ASM_SRC))

TEST_ASM_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-asm: $(TEST_ASM_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_ASM_LIB)

#-------------------------------------------------------------------------------
# test-md5append
#
TEST_MD5APPEND_SRC = \
	md5appendtest

TEST_MD5APPEND_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_MD5APPEND_SRC))

TEST_MD5APPEND_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-md5append: $(TEST_MD5APPEND_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_MD5APPEND_LIB)

#-------------------------------------------------------------------------------
# test-printf
#
TEST_PRINTF_SRC = \
	printf-test

TEST_PRINTF_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_PRINTF_SRC))

TEST_PRINTF_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-printf: $(TEST_PRINTF_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_PRINTF_LIB)

#-------------------------------------------------------------------------------
# test-log
#
TEST_LOG_SRC = \
	test-log

TEST_LOG_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_LOG_SRC))

TEST_LOG_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-log: $(TEST_LOG_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LOG_LIB)

#-------------------------------------------------------------------------------
# test-SraReleaseVersion
#
TEST_SRA_RELEASE_VERSION_SRC = \
	test-SraReleaseVersion

TEST_SRA_RELEASE_VERSION_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_SRA_RELEASE_VERSION_SRC))

TEST_SRA_RELEASE_VERSION_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \


$(TEST_BINDIR)/test-SraReleaseVersion: $(TEST_SRA_RELEASE_VERSION_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_SRA_RELEASE_VERSION_LIB)

valgrind_sra_release_version:
	valgrind --ncbi $(TEST_BINDIR)/test-SraReleaseVersion

.PHONY: valgrind_SraReleaseVersion


#-------------------------------------------------------------------------------
# test-time
#
TEST_TIME_SRC = \
	test-time

TEST_TIME_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_TIME_SRC))
    
$(TEST_BINDIR)/test-time: $(TEST_TIME_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_SRA_RELEASE_VERSION_LIB)

#-------------------------------------------------------------------------------
# test-out
#
TEST_OUT_SRC = \
	test-out

TEST_OUT_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_OUT_SRC))

TEST_OUT_LIB = \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-out: $(TEST_OUT_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_OUT_LIB)

#-------------------------------------------------------------------------------
# test-klib
#
TEST_KLIB_SRC = \
	test-klib

TEST_KLIB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_KLIB_SRC))

TEST_KLIB_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-klib: $(TEST_KLIB_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_KLIB_LIB)


#-------------------------------------------------------------------------------
# test-vnamelist
#
TEST_VNAMELIST_SRC = \
	test-vnamelist

TEST_VNAMELIST_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_VNAMELIST_SRC))

TEST_VNAMELIST_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-vnamelist: $(TEST_VNAMELIST_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_VNAMELIST_LIB)

VNAMELIST: test-vnamelist
	$(TEST_BINDIR)/test-vnamelist

#-------------------------------------------------------------------------------
# test-progressbar
#
TEST_PROGRESSBAR_SRC = \
	test-progress

TEST_PROGRESSBAR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_PROGRESSBAR_SRC))

TEST_PROGRESSBAR_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-progressbar: $(TEST_PROGRESSBAR_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_PROGRESSBAR_LIB)

PROGRESSBAR: test-progressbar
	$(TEST_BINDIR)/test-progressbar

#-------------------------------------------------------------------------------
# test-symtab
#
TEST_SYMTAB_SRC = \
	test-symtab

TEST_SYMTAB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_SYMTAB_SRC))

TEST_SYMTAB_LIB = \
	-skapp \
	-sncbi-vdb \
	-sktst \

$(TEST_BINDIR)/test-symtab: $(TEST_SYMTAB_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_SYMTAB_LIB)

symtab: test-symtab
	$(TEST_BINDIR)/test-symtab

=== test/schema/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: runtests

TOP ?= $(abspath ../..)

MODULE = test/schema

TEST_TOOLS = \
	wb-test-schema-lex \
	wb-test-schema-parser \
	wb-test-schema-ast \

INT_TOOLS = \
    test-schema-scan \
    test-schema-parse \
    test-schema-diff \

ALL_TOOLS = $(TEST_TOOLS) $(INT_TOOLS)

include $(TOP)/build/Makefile.env

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(ALL_TOOLS)

clean: stdclean

TEST_LIB = \
	-sktst \
	-skapp \
    -sncbi-vdb \
    -sschema \

#-------------------------------------------------------------------------------
# white box lexer test
#
TESTLEX_SRC = \
	wb-test-schema-lex

TESTLEX_OBJ = \
	$(addsuffix .$(OBJX),$(TESTLEX_SRC))

$(TEST_BINDIR)/wb-test-schema-lex: $(TESTLEX_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# black box scanner test
#
TESTSCAN_SRC = \
	test-schema-scan

TESTSCAN_OBJ = \
	$(addsuffix .$(OBJX),$(TESTSCAN_SRC))

$(TEST_BINDIR)/test-schema-scan: $(TESTSCAN_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# white box parser test
#
TESTGRAM_SRC = \
	wb-test-schema-parser

TESTGRAM_OBJ = \
	$(addsuffix .$(OBJX),$(TESTGRAM_SRC))

$(TEST_BINDIR)/wb-test-schema-parser: $(TESTGRAM_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# black box parser test
#
TESTPARSE_SRC = \
	test-schema-parse

TESTPARSE_OBJ = \
	$(addsuffix .$(OBJX),$(TESTPARSE_SRC))

$(TEST_BINDIR)/test-schema-parse: $(TESTPARSE_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# old vs new schema matching
#
TESTDIFF_SRC = \
	test-schema-diff

TESTDIFF_OBJ = \
	$(addsuffix .$(OBJX),$(TESTDIFF_SRC))

$(TEST_BINDIR)/test-schema-diff: $(TESTDIFF_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# AST test
#
TESTAST_SRC = \
	AST_Fixture \
	wb-test-schema-ast \

TESTAST_OBJ = \
	$(addsuffix .$(OBJX),$(TESTAST_SRC))

$(TEST_BINDIR)/wb-test-schema-ast: $(TESTAST_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_LIB)

#-------------------------------------------------------------------------------
# runtests
#
runtests: scantest parsetest difftest

SCHEMATA := $(shell find $(TOP) -name "*.vschema")

scantest: test-schema-scan
	@mkdir -p $(SRCDIR)/actual;
	$(TEST_BINDIR)/test-schema-scan $(SCHEMATA)
	@echo "Schema scanner test complete"

parsetest: test-schema-parse
	-$(TEST_BINDIR)/test-schema-parse $(SCHEMATA)
	@echo "Schema parser test complete"

difftest: test-schema-diff
	mkdir -p $(OBJDIR)/data
	-$(TEST_BINDIR)/test-schema-diff -I$(TOP)/interfaces -o$(OBJDIR)/data \
	$(addprefix	$(TOP)/interfaces/, \
		insdc/insdc.vschema \
		insdc/seq.vschema \
		insdc/sra.vschema \
		ncbi/ncbi.vschema \
		ncbi/seq.vschema \
		ncbi/spotname.vschema \
		ncbi/sra.vschema \
		ncbi/stats.vschema \
		ncbi/seq-graph.vschema \
		ncbi/wgs-contig.vschema \
		ncbi/clip.vschema \
		ncbi/varloc.vschema \
		ncbi/pnbrdb.vschema \
		vdb/built-in.vschema \
		vdb/vdb.vschema \
		align/mate-cache.vschema \
		align/refseq.vschema \
		align/seq.vschema \
		align/qstat.vschema \
		align/align.vschema \
		align/pileup-stats.vschema \
		sra/454.vschema \
		sra/ion-torrent.vschema \
		sra/illumina.vschema \
		sra/abi.vschema \
		sra/helicos.vschema \
		sra/nanopore.vschema \
		sra/generic-fastq.vschema \
		sra/pacbio.vschema \
		csra2/stats.vschema \
		csra2/read.vschema \
		csra2/reference.vschema \
		csra2/csra2.vschema \
	) \
	$(TOP)/libs/sra/built-in.vschema
#	$(TOP)/test/loader/sequencewriter.vschema
#	$(TOP)/interfaces/sra/pevents.vschema
	@echo "Schema diff test complete"

.PHONY: scantest parsetest difftestdiff

=== test/vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/vdb

TEST_TOOLS = \
	test-vdb \
	test-wvdb \
	test-dependencies \
	test-sparse-col-rw \
	test-sparse-col-rd \
	test-blob-val \
	test-VDB-3060 \
	test-VDB-3061

#	test-VDB-3418

include $(TOP)/build/Makefile.env


# make sure runs are not cached in the user repository when running tests
ifeq ($(wildcard ../../../asm-trace),)
	ifeq (,$(VDB_CONFIG))
		VDB_CONFIG = $(shell pwd)/../only-remote-repository.kfg
	endif
endif


$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

runtests: setup 

setup:
	@ mkdir -p db

.PHONY: $(TEST_TOOLS) setup

clean: stdclean


#-------------------------------------------------------------------------------
# test-vdb
#
TEST_VDB_SRC = \
	test-vdb

TEST_VDB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_VDB_SRC))

TEST_VDB_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/test-vdb: $(TEST_VDB_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_VDB_LIB)

vdb: test-vdb
	$(TEST_BINDIR)/test-vdb    

valgrind_vdb: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-vdb    

#-------------------------------------------------------------------------------
# test-dependencies
#
TEST_DEPS_SRC = \
	test-dependencies

TEST_DEPS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_DEPS_SRC))

TEST_DEPS_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/test-dependencies: $(TEST_DEPS_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_DEPS_LIB)

valgrind_deps: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-dependencies    

#-------------------------------------------------------------------------------
# test-wvdb
#
TEST_WVDB_SRC = \
	test-wvdb

TEST_WVDB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_WVDB_SRC))

TEST_WVDB_LIB = \
	-skapp \
	-sktst \
	-sncbi-wvdb \

$(TEST_BINDIR)/test-wvdb: $(TEST_WVDB_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_WVDB_LIB)

wvdb: test-wvdb
	$(TEST_BINDIR)/test-wvdb    

valgrind_wvdb: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-wvdb    

#-------------------------------------------------------------------------------
# test-sparse-col
#  We will compile the same test file first in read/write mode, create DB and
#  run tests using libncbi-wvdb library; then compile the same test with -DREAD_ONLY 
#  and link it against read-only lincbi-vdb library
TEST_SPARSE_COL_SRC = \
	test-sparse-col

TEST_SPARSE_COL_OBJ_RW = \
	$(addsuffix .$(OBJX),$(TEST_SPARSE_COL_SRC)-rw)
	
TEST_SPARSE_COL_OBJ_RD = \
	$(addsuffix .$(OBJX),$(TEST_SPARSE_COL_SRC)-rd)

TEST_SPARSE_COL_LIB = \
	-skapp \
	-sktst \

$(TEST_SPARSE_COL_OBJ_RW): $(TEST_SPARSE_COL_SRC).cpp
	$(CP) -o $@ $(OPT) $< $(LOC_INFO) -D__file_ext__=cpp

$(TEST_SPARSE_COL_OBJ_RD): $(TEST_SPARSE_COL_SRC).cpp
	$(CP) -o $@ $(OPT) $< $(LOC_INFO) -D__file_ext__=cpp -DREAD_ONLY	

$(TEST_BINDIR)/test-sparse-col-rw: $(TEST_SPARSE_COL_OBJ_RW)
	$(LP) --exe -o $@ $^ $(TEST_SPARSE_COL_LIB) -sncbi-wvdb

$(TEST_BINDIR)/test-sparse-col-rd: $(TEST_SPARSE_COL_OBJ_RD)
	$(LP) --exe -o $@ $^ $(TEST_SPARSE_COL_LIB) -sncbi-vdb

sparse-col: test-sparse-col-rw test-sparse-col-rd
	$(TEST_BINDIR)/test-sparse-col-rw
	$(TEST_BINDIR)/test-sparse-col-rd

valgrind_sparse-col: std
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-sparse-col-rw
	valgrind --ncbi --show-reachable=no $(TEST_BINDIR)/test-sparse-col-rd   
	
#-------------------------------------------------------------------------------
# test-blob-val
#
TEST_BLOB_VAL_SRC = \
	test-blob-val

TEST_BLOB_VAL_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_BLOB_VAL_SRC))
	
TEST_BLOB_VAL_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/test-blob-val: $(TEST_BLOB_VAL_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_BLOB_VAL_LIB)

blob-val: test-blob-val
	$(TEST_BINDIR)/test-blob-val

#-------------------------------------------------------------------------------
# SYS-224064
#
SYS_224064_SRC = \
	SYS-224064

SYS_224064_OBJ = \
	$(addsuffix .$(OBJX),$(SYS_224064_SRC))

SYS_224064_LIB = \
	-sncbi-vdb \

$(TEST_BINDIR)/SYS-224064: $(SYS_224064_OBJ)
	$(LP) --exe -o $@ $^ $(SYS_224064_LIB)

SYS-224064: makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@


#-------------------------------------------------------------------------------
# VDB-3060
#
VDB_3060_SRC = \
	test-VDB-3060

VDB_3060_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3060_SRC))

VDB_3060_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-VDB-3060: $(VDB_3060_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_3060_LIB)

VDB-3060: test-VDB-3060
	$(TEST_BINDIR)/test-VDB-3060

#-------------------------------------------------------------------------------
# VDB-3061
#
VDB_3061_SRC = \
	test-VDB-3061

VDB_3061_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3061_SRC))

VDB_3061_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-VDB-3061: $(VDB_3061_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_3061_LIB)

VDB-3061: test-VDB-3061
	$(TEST_BINDIR)/test-VDB-3061

#-------------------------------------------------------------------------------
# VDB-3305
#
VDB_3305_SRC = \
	test-VDB-3305

VDB_3305_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3305_SRC))

VDB_3305_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-VDB-3305: $(VDB_3305_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_3305_LIB)

VDB-3305: test-VDB-3305
	$(TEST_BINDIR)/test-VDB-3305


#-------------------------------------------------------------------------------
# VDB-3418
#
VDB_3418_SRC = \
	test-VDB-3418

VDB_3418_OBJ = \
	$(addsuffix .$(OBJX),$(VDB_3418_SRC))

VDB_3418_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-VDB-3418: $(VDB_3418_OBJ)
	$(LP) --exe -o $@ $^ $(VDB_3418_LIB)

VDB-3418: test-VDB-3418
	$(TEST_BINDIR)/test-VDB-3418
